
	CHAR_MASK		=	FREE_D9		; byte usado para fazer AND no texto para compatibilidade com Apple][ sem letra minuscula
	IS_APPLE2		=	FREE_1E
	HTAB		=	$24
	VTAB		=	$25

	PRINT_DATA	=	FREE_EE
	CHKSUM		= 	UNK_I_FE
	
	PREAD		=	$FB1E
	VERSION		=	$FBB3
	
SYSTEM:
SYSTEM_INIT:
	lda		#$ff
	sta		CHAR_MASK
	sta		IS_APPLE2

	SYS		CB2K_SYSTEM_IDENTIFICATION

	tax
	and		#CB2K_MACHINE_TK2000_FAMILY_MASK
	cmp		#CB2K_MACHINE_TK2000_FAMILY_MASK		;  TK2000?
	beq		@tk2000									; Sim

	txa
	and		#CB2K_MACHINE_APPLE_2_FAMILY_MASK
	cmp		#CB2K_MACHINE_APPLE_2_FAMILY_MASK		; Apple II / II+ ?
	beq		@upcase_only							; Sim
	bne		@lowcase_capable						; No
	
@tk2000:
	lda		#0
	sta		IS_APPLE2
	
@upcase_only:
	lda		#$DF
	sta		CHAR_MASK
	
@lowcase_capable:
	jsr		MON_SETKBD
	jsr		MON_SETVID
	
	bit		IS_APPLE2
	beq		:+
	jsr		MON_INIT
	jmp		MON_HOME	
:	; Para o TK-2000
	lda		TK2K_HW_TEXTBW
	jsr		TK2K_MON_INIT1
	jmp		MON_HOME
	
PRINT_TEXT:
	sta		PRINT_DATA
	sty		PRINT_DATA+1
	ldy		#0
	sty		CHKSUM
:
	jsr		@_get
	bmi		@exit
	sta		VTAB
	jsr		@_get
	sta		HTAB
	
	jsr		@print

	clc
	bcc		:-

@print:
	jsr		@_get
	beq		@eol
	
	bit		IS_APPLE2
	beq		:+
	pha
	lda		VTAB
	jsr		MON_BASCALC
	pla	
:	
	jsr		PRINT_CHAR
	
	clc
	bcc		@print
@exit:
	lda		CHKSUM
@eol:
	rts

@_get:
	lda 	(PRINT_DATA),y
	php
	iny
	bne		:+
	inc		PRINT_DATA+1
:
	pha
	eor		CHKSUM
	sta		CHKSUM
	pla
	plp
	rts

PRINT_ASCII:
	ora		#$80
PRINT_CHAR:
	cmp		#$61|$80
	bcc		:+
	and		CHAR_MASK
:	
	jmp		MON_COUT

SYSTEM_TEXT:
	bit		IS_APPLE2
	beq		:+
	jmp		APPLESOFT_CMD_TEXT
:	jmp		TK2K_APPLESOFT_CMD_TEXT

SYSTEM_HGR:
	bit		IS_APPLE2
	beq		:+
	jmp		APPLESOFT_CMD_HGR
:	jmp		TK2K_APPLESOFT_CMD_HGR	

SYSTEM_APPLESOFT_START_COLD:
	bit		IS_APPLE2
	beq		:+
	jmp		APPLESOFT_START_COLD
:	jmp		TK2K_APPLESOFT_START_COLD	

;*-------------------------------
;* Rotina de leitura do teclado
;* Deve ler diferente para o
;* apple2 e o tk2000
;*-------------------------------
.proc	KEYPRESSED
		bit		IS_APPLE2				;  Apple2?
		bpl		TK2000					; No, pulamos para a rotina correta
										; Aqui  para o Apple2:
		bit		HW_KEYBOARD_IN			; key pressed?
		rts
		
TK2000:
		; Negative = 1 : no key press detected
		; Negative = 0 : a key was pressed
		pha
		lda		#$FF
		sta		TK2K_HW_KEYBOARD_SELECT_EXTRA_ON
		sta		TK2K_HW_KEYBOARD_SELECT_ROW
		lda		TK2K_HW_KEYBOARD_READ
		and		#%00111111
		bne		@key_pressed
		pla
		bit		@NOKEY
		rts
@key_pressed:
		pla
		bit		@KEYPRESSED
		rts
@NOKEY:			.byte	$00
@KEYPRESSED:	.byte	$80
.endproc
		
.proc	INKEY
		bit		IS_APPLE2				;  Apple2?
		bpl		TK2000					; No, pulamos para a rotina correta
										; Aqui  para o Apple2:
		lda		HW_KEYBOARD_IN			; key pressed?
		bpl		:+
		bit		HW_KEYBOARD_STROBE		; limpa ltima tecla pressionada
:
		rts
TK2000:
		jsr		INKEY::TK2000
		bpl	:+
		jsr		@INKEY_TK2000_ORIGINAL
:   	rts

@INKEY_TK2000_ORIGINAL:
		lda		$26						; Copiada do manual do tk2000
		pha								; Salva endereos da pgina 0 que so mudados
		lda		$27						; pela rotina SCAN1, restaurando-os no final
		pha
		lda		$06
		pha
		lda		$07
		pha
		lda		$08
		pha
		lda		$09
		pha
		jsr		TK2K_MON_SCAN1
		pha
		txa
		pha
		tsx
		txa
		eor		#$80
		tax
		pla
		sta		$100,x
		inx
		pla
		sta		$100,x
		pla
		sta		$09
		pla
		sta		$08
		pla
		sta		$07
		pla
		sta		$06
		pla
		sta		$27
		pla
		sta		$26
		lda		$100,x
		pha
		dex
		lda		$100,x
		tax
		pla
		rts
.endproc
